(define-module (skylark services audio)
  #:use-module (guix gexp)
  #:use-module ((gnu services) #:hide (delete))
  #:use-module (gnu home services shepherd)
  #:use-module (gnu services audio)
  #:use-module (gnu packages mpd)
  #:export (home-mpd-service-type))

(define (home-mpd-shepherd-service config)
  (let ((config-file (mpd-serialize-configuration config)))
    (shepherd-service
     (documentation "Run the MPD (Music Player Daemon)")
     (provision '(mpd-home))
     (start
      #~(make-forkexec-constructor
         (list #$(file-append package "/bin/mpd") "--no-daemon"
               #$config-file)))
     (stop #~(make-kill-destructor)))))

(define home-mpd-service-type
  (service-type
   (name 'mpd-home)
   (description "Run the Music Player Daemon (MPD).")
   (extensions
    (list (service-extension home-shepherd-service-type
                             (compose list home-mpd-shepherd-service))))
   (default-value (mpd-configuration))))
